    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * DateTickMarkPosition.java
    029     * -------------------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: DateTickMarkPosition.java,v 1.4.2.1 2005/10/25 20:37:34 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 30-Apr-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.axis;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Used to indicate the required position of tick marks on a date axis relative
    050     * to the underlying time period.
    051     */
    052    public final class DateTickMarkPosition implements Serializable {
    053
    054        /** For serialization. */
    055        private static final long serialVersionUID = 2540750672764537240L;
    056
    057        /** Start of period. */
    058        public static final DateTickMarkPosition START
    059            = new DateTickMarkPosition("DateTickMarkPosition.START");
    060
    061        /** Middle of period. */
    062        public static final DateTickMarkPosition MIDDLE
    063            = new DateTickMarkPosition("DateTickMarkPosition.MIDDLE");
    064
    065        /** End of period. */
    066        public static final DateTickMarkPosition END
    067            = new DateTickMarkPosition("DateTickMarkPosition.END");
    068
    069        /** The name. */
    070        private String name;
    071
    072        /**
    073         * Private constructor.
    074         *
    075         * @param name  the name.
    076         */
    077        private DateTickMarkPosition(String name) {
    078            this.name = name;
    079        }
    080
    081        /**
    082         * Returns a string representing the object.
    083         *
    084         * @return The string.
    085         */
    086        public String toString() {
    087            return this.name;
    088        }
    089
    090        /**
    091         * Returns <code>true</code> if this object is equal to the specified
    092         * object, and <code>false</code> otherwise.
    093         *
    094         * @param obj  the other object.
    095         *
    096         * @return A boolean.
    097         */
    098        public boolean equals(Object obj) {
    099
    100            if (this == obj) {
    101                return true;
    102            }
    103            if (!(obj instanceof DateTickMarkPosition)) {
    104                return false;
    105            }
    106            DateTickMarkPosition position = (DateTickMarkPosition) obj;
    107            if (!this.name.equals(position.toString())) {
    108                return false;
    109            }
    110            return true;
    111
    112        }
    113
    114        /**
    115         * Ensures that serialization returns the unique instances.
    116         *
    117         * @return The object.
    118         *
    119         * @throws ObjectStreamException if there is a problem.
    120         */
    121        private Object readResolve() throws ObjectStreamException {
    122            if (this.equals(DateTickMarkPosition.START)) {
    123                return DateTickMarkPosition.START;
    124            }
    125            else if (this.equals(DateTickMarkPosition.MIDDLE)) {
    126                return DateTickMarkPosition.MIDDLE;
    127            }
    128            else if (this.equals(DateTickMarkPosition.END)) {
    129                return DateTickMarkPosition.END;
    130            }
    131            return null;
    132        }
    133
    134
    135    }